#include <AccelStepper.h>
#include <math.h>
#include <RTClib.h>
RTC_DS3231 rtc;
float hour, minute, second;
#define HALFSTEP 8
long initial_homing=-1;
float SR1= 147.456;
float SR2= -24.288;
int teller = 1000;
boolean action = HIGH;
float zeroalpha = -0.18; //was -0.17; //was -0.1126;
float zerobeta = 2.39; // was 2.38; // was 2.361;
float zerox  = 10.5;
float zeroy = 19.5;
float x = -15;
float y = 50;
double l = 0;
double d = 0;
double epsilon = 0;
double omega = 0;
double alpha = 0;
double beta = 0;
float xt = zerox;
float yt = zeroy;
//float targetx;
//loat targety;

// Motor pin definitions
#define motor1Pin1  A0     // IN1 on the ULN2003 driver 1
#define motor1Pin2  A1     // IN2 on the ULN2003 driver 1
#define motor1Pin3  A2    // IN3 on the ULN2003 driver 1
#define motor1Pin4  A3     // IN4 on the ULN2003 driver 1
#define motor2Pin1  4     // IN1 on the ULN2003 driver 2
#define motor2Pin2  6     // IN2 on the ULN2003 driver 2
#define motor2Pin3  5    // IN3 on the ULN2003 driver 2
#define motor2Pin4  7     // IN4 on the ULN2003 driver 2
#define motor3Pin1  8     // IN1 on the ULN2003 driver 2
#define motor3Pin2  10     // IN2 on the ULN2003 driver 2
#define motor3Pin3  9    // IN3 on the ULN2003 driver 2
#define motor3Pin4  11     // IN4 on the ULN2003 driver 2

// Initialize with pin sequence IN1-IN3-IN2-IN4 for using the AccelStepper with 28BYJ-48
AccelStepper stepper1(HALFSTEP, motor1Pin1, motor1Pin3, motor1Pin2, motor1Pin4);
AccelStepper stepper2(HALFSTEP, motor2Pin1, motor2Pin3, motor2Pin2, motor2Pin4);
AccelStepper stepper3(HALFSTEP, motor3Pin1, motor3Pin3, motor3Pin2, motor3Pin4);

void setup() {
  //  is power has been lost of RTC timer:
  //  rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
  Serial.begin(9600);
  stepper1.setMaxSpeed(1500.0);     stepper2.setMaxSpeed(1000.0);     stepper3.setMaxSpeed(1500.0);
  stepper1.setAcceleration(90000.0); stepper2.setAcceleration(80000.0); stepper3.setAcceleration(2000.0);
  stepper1.setSpeed(1500);          stepper2.setSpeed(1000);          stepper3.setSpeed(1500);

pinMode(2,INPUT_PULLUP);
pinMode(13,INPUT_PULLUP);
pinMode(12,INPUT_PULLUP);
zero();

}//--(end setup )---

//*************************************
//*************************************
void loop() {
water();
HourMark();
urenwijzer();
minuutwijzer();
zero();
}

void zero(){
//1==================================1 
 initial_homing=-1;
 stepper1.setCurrentPosition(0);
 stepper1.moveTo(800);  
 stepper1.runToPosition();
  while (digitalRead(2)) {  // Make the Stepper move until the switch is activated   
    stepper1.moveTo(initial_homing);  // Set the first position to move to
    initial_homing--;  // Decrease by 1 for next move if needed
    stepper1.run();  // Start moving the stepper
  }   //if (distanceToGo() ==0){
  stepper1.setCurrentPosition(0);
//2==================================2  
 initial_homing=-1;
 stepper2.setCurrentPosition(0);
 stepper2.moveTo(100);  
 stepper2.runToPosition();
  while (digitalRead(13)) {  // Make the Stepper move until the switch is activated   
    stepper2.moveTo(initial_homing);  // Set the first position to move to
    initial_homing--;  // Decrease by 1 for next move if needed
    stepper2.run();  // Start moving the stepper
  }   //if (distanceToGo() ==0){
  stepper2.setCurrentPosition(0);
//3==================================3
 stepper3.setCurrentPosition(0);
 stepper3.moveTo(-100);  
 initial_homing=1;
 stepper3.runToPosition();
  while (digitalRead(12)) {  // Make the Stepper move until the switch is activated   
    stepper3.moveTo(initial_homing);  // Set the first position to move to
    initial_homing++;  // Decrease by 1 for next move if needed
    stepper3.run();  // Start moving the stepper
  }   //if (distanceToGo() ==0){
  stepper3.setCurrentPosition(0);
}

void water(){
zerox = 10.5;
zeroy = 19.5;
 Serial.println("Water");
 for(int i = 0; i<500; i++){
 xt = xt + (0-zerox)/500;
 yt = yt + (57-zeroy)/500;
 l=sqrt(xt*xt+yt*yt)/2;
 d=sqrt(30*30-l*l);
 epsilon=atan(d/l);
 omega=atan(xt/yt);
 alpha=PI/2-epsilon-omega;
 beta=2*epsilon; 
    stepper1.moveTo(1000*SR1*(alpha-zeroalpha)/(2*PI));  
    stepper1.runToPosition();
    stepper2.moveTo(1000*SR2*(beta-zerobeta)/(2*PI));  
    stepper2.runToPosition();
  }
xt = 0 ;
yt = 57 ; 
     Serial.println("WaterReady");
}
void penseelUP(){
  stepper3.moveTo(-2000);  
  stepper3.runToPosition();
}
void penseelDOWN(){
  stepper3.moveTo(-4000);  
  stepper3.runToPosition();
}
void lijntekenen(){
  zerox = xt;
  zeroy = yt;
    for(int i = 0; i<1000; i++){
      xt = xt + (x-zerox)/1000;  
      yt = yt + (y-zeroy)/1000;
      l=sqrt(xt*xt+yt*yt)/2;
      d=sqrt(30*30-l*l);
      epsilon=atan(d/l);
      omega=atan(xt/yt);
      alpha=PI/2-epsilon-omega;
      beta=2*epsilon;
      stepper1.moveTo(1000*SR1*(alpha-zeroalpha)/(2*PI));  
      stepper1.runToPosition();
      stepper2.moveTo(1000*SR2*(beta-zerobeta)/(2*PI));  
      stepper2.runToPosition();
      }
  xt = x;
  yt = y;
}
void minuutwijzer(){                //minutehand
  DateTime now = rtc.now();
  hour=now.hour();
  minute=now.minute();
 x = -15*sin((minute*2*PI)/60);     //calculate x position
 y = 39-15*cos((minute*2*PI)/60);   //calculate y position
  lijntekenen();                    //linedraw
  penseelDOWN();                    //brushdown
x = 0;                              //centrepoint x-position
y = 38;                             //centrepoint y-position
  lijntekenen();                     //linedraw
  penseelUP();                      //brushup
  x=10;                             //upper left resting x-position
  y=20;                             //upper left resting y-position
  lijntekenen();                    //linedraw
}
void urenwijzer(){
  DateTime now = rtc.now();
  hour=now.hour();
  minute=now.minute();
x = -10*sin(((hour+(minute/60))*2*PI)/12);
y = 39-10*cos(((hour+(minute/60))*2*PI)/12);
   lijntekenen();
   penseelDOWN();
x = 0;
 y = 38;
lijntekenen();
penseelUP();
}
void HourMark(){
  for (float k=0 ; k<12 ; k++){
   x = -17*sin((k/6)*PI);     //calculate x position
   y = 39-17*cos((k/6)*PI);   //calculate y position
   lijntekenen();
   x = -14*sin((k/6)*PI);     //calculate x position
   y = 39-14*cos((k/6)*PI);   //calculate y position
   penseelDOWN();
   lijntekenen();
   penseelUP();  
  }
}
